
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Sales_allocationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sales_allocations = await db.sales_allocations.create(
            {
                id: data.id || undefined,
        
        quantity: data.quantity
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await sales_allocations.setSales_order_line( data.sales_order_line || null, {
            transaction,
        });
        
        await sales_allocations.setLot( data.lot || null, {
            transaction,
        });
        
        await sales_allocations.setSerial_number( data.serial_number || null, {
            transaction,
        });
        
        await sales_allocations.setLocation( data.location || null, {
            transaction,
        });
        
        await sales_allocations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return sales_allocations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const sales_allocationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity: item.quantity
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const sales_allocations = await db.sales_allocations.bulkCreate(sales_allocationsData, { transaction });

        // For each item created, replace relation files
        

        return sales_allocations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const sales_allocations = await db.sales_allocations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        updatePayload.updatedById = currentUser.id;

        await sales_allocations.update(updatePayload, {transaction});

        
        
        if (data.sales_order_line !== undefined) {
            await sales_allocations.setSales_order_line(
              
              data.sales_order_line,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await sales_allocations.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.serial_number !== undefined) {
            await sales_allocations.setSerial_number(
              
              data.serial_number,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await sales_allocations.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await sales_allocations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return sales_allocations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sales_allocations = await db.sales_allocations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of sales_allocations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of sales_allocations) {
                await record.destroy({transaction});
            }
        });


        return sales_allocations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const sales_allocations = await db.sales_allocations.findByPk(id, options);

        await sales_allocations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await sales_allocations.destroy({
            transaction
        });

        return sales_allocations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const sales_allocations = await db.sales_allocations.findOne(
            { where },
            { transaction },
        );

        if (!sales_allocations) {
            return sales_allocations;
        }

        const output = sales_allocations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.sales_order_line = await sales_allocations.getSales_order_line({
            transaction
        });
        
        
        output.lot = await sales_allocations.getLot({
            transaction
        });
        
        
        output.serial_number = await sales_allocations.getSerial_number({
            transaction
        });
        
        
        output.location = await sales_allocations.getLocation({
            transaction
        });
        
        
        output.organizations = await sales_allocations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.sales_order_lines,
        as: 'sales_order_line',
        
        where: filter.sales_order_line ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sales_order_line.split('|').map(term => Utils.uuid(term)) } },
            {
              description: {
                [Op.or]: filter.sales_order_line.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.serial_numbers,
        as: 'serial_number',
        
        where: filter.serial_number ? {
          [Op.or]: [
            { id: { [Op.in]: filter.serial_number.split('|').map(term => Utils.uuid(term)) } },
            {
              serial_number: {
                [Op.or]: filter.serial_number.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.sales_allocations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'sales_allocations',
                        'quantity',
                        query,
                    ),
                ],
            };
        }

        const records = await db.sales_allocations.findAll({
            attributes: [ 'id', 'quantity' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['quantity', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.quantity,
        }));
    }

    
};

